#include <stdio.h>
#include <time.h>
#include <stdlib.h>

#define Nmax 100000


/*Scopo del programma e' quello di popolare un array con numeri casuali estratti*/
/*con la funzione randomn  */
/*Quindi calcoliamo la media e lo scarto quadratico medio di questo set di numeri pseudocasuali*/
/*in due modi: con due funzioni dedicate (media e sigma2)*/
/*con una sola funzione dedicata che restituisca 2 valori (!)*/

double randomn(double ,double);

/*Approccio semplice: 2 funzioni per 2 valori:*/
/*Come al solito uno degli argomenti e' un array quindi adottiamo come primo argomento double * */
double media(double *,int );
double sigma2(double *,double ,int);


/*Approccio piu' complesso:*/
/*Estendiamo il concetto di passare alla funzione un indirizzo piuttosto che dei valori :*/
/*Definiamo una funzione i cui argomenti sono double * per l'array, e poi due puntatori double */
/*a delle variabili che definiamo nel main e che conterranno infine la media e la varianza*/
/*non potendo ritornare valori multipli agiamo cosi' da sfruttare a pieno i concetti visti a lezione*/


void advanced(double *,double*, double*,int);
/*La funzione non ritorna nessun valore (quindi void!) ma cambier i valori di due variabili,*/
/*che chiameremo ave,a2 nel main (poiche' stiamo sfruttando il passaggio degli indirizzi!)*/

/*Ho chiamato la funzione advanced, ma di fatto e' la prassi:) */



/*Vi faccio vedere la definizione esplicita del main*/
int main(void){

  int i;
  double xmin=0.,xmax=1.,rarray[Nmax],ave=0,s2=0;
  int seed;


  seed = time(0);
  srand48(seed);

  for (i=0;i<Nmax;i++){
    *(rarray+i)=randomn(xmin,xmax);
  }
  
  /*funzione media semplice*/
  ave=media(rarray,Nmax);
  printf("MEDIA %20.10lf \n",ave);

  /*funzione sigma2 che prende in input rarray e la media (ave)) oltre la dimensione*/

  
  printf("SIGMA2 %20.10lf \n",sigma2(rarray,ave,Nmax));

 

  /*funzione avanzata, passiamo l'array,gli indirizzi delle variabili ave e s2 e la dimensione di rarray*/
  /* advanced(rarray,&ave,&s2,Nmax); rimettiamoli a zero cosi' da fugare ogni dubbio*/

  ave=0;
  s2=0;

  advanced(rarray,&ave,&s2,Nmax);

  /*I valori sono stati cambiati ?*/
  
  printf("MEDIA con seconda funzione %20.10lf \n",ave);
  printf("SIGMA2 con seconda funzione %20.10lf \n",s2);

  /*anche exit e' una funzione!*/
  exit(0);

}


double randomn(double a,double b){
  double rn;
  rn=a+(b-a)*(double)lrand48()/RAND_MAX;
  return rn;
}
      
/*Di nuovo in definizione ho esplicitato che a e' un array mettendo []*/
double media(double a[] ,int n){
  int i;
  double av=0;
  
  for(i=0;i<n;i++)
      av+=*(a+i);

  av=av/n;

  return av;
}

double sigma2(double a[],double md,int n){
  int i;
  double s2=0;
  for(i=0;i<n;i++)
    s2+=(*(a+i)-md)*(*(a+i)-md);
  s2=s2/(n-1);
  return s2;
}

/*Devo specificare che ave e s2 sono dei puntatori a variabili di tipo double*/

void advanced(double a[],double *ave,double *s2,int n){
  int i;
  double media=0,media2=0;
  
  for(i=0;i<n;i++){
    /*Qui riuso l'espressione classica per gli array tanto per non farvi perdere di vista il messaggio*/
    /*Utilizziamo la proprieta' descritta a lezione per lo scarto. E' molto piu' economica (che significa*/
    /*che richiede meno operazioni matematiche)*/
    media=media+a[i];
    media2=media2+a[i]*a[i];
  }


  media=media/n;
  media2=media2/n;

  /*Sfrutto la proprieta' che sigma2=n/(n-1)*var2=n/(n-1)*(media(x^2)-media(x)^2)*/

  /*Cambio i valori alle variabili puntate da *ave e *s2*/
  *ave=media;
  *s2=(double)n/(n-1)*(media2-media*media);
}
      
      




    
